#!/bin/bash

# we need root
if [[ `whoami` != "root" ]]; then
  echo "we need root, and we are: $( whoami ); exiting!.."
  exit 1
fi

# sanity check
if [[ "$APP_NAME" == "" || "$APP_USER" == "" || "$APP_GROUP" == "" ]]; then
  echo '$APP_NAME, $APP_USER or $APP_GROUP are not set'
  exit 2
fi

# info
echo "\$APP_NAME  :: $APP_NAME"
echo "\$APP_USER  :: $APP_USER"
echo "\$APP_GROUP :: $APP_GROUP"

# log, run and data
mkdir -p /var/log/php-fpm
mkdir -p /var/run/php-fpm
mkdir -p /opt/php
chown $APP_USER:$APP_GROUP /var/log/php-fpm
chown $APP_USER:$APP_GROUP /var/run/php-fpm
chown $APP_USER:$APP_GROUP /opt/php

# php.ini customizations.
sed -i "s/upload_max_filesize = 2M/upload_max_filesize = 10M/g" /etc/php5/fpm/php.ini
sed -i "s/post_max_size = 8M/post_max_size = 10M/g" /etc/php5/fpm/php.ini

# PHP-FPM pool configuration.
mv /etc/php5/fpm/pool.d/pool.conf /etc/php5/fpm/pool.d/$APP_NAME.conf
sed -i "s/pool_name/$APP_NAME/g" /etc/php5/fpm/pool.d/$APP_NAME.conf
sed -i "s/app_user/$APP_USER/g" /etc/php5/fpm/pool.d/$APP_NAME.conf
sed -i "s/app_group/$APP_GROUP/g" /etc/php5/fpm/pool.d/$APP_NAME.conf

# Change the default error log location.
sed -i "s@error_log = /var/log/php5-fpm.log@error_log = /var/log/php-fpm/$APP_NAME-php-fpm5.access.log@g" /etc/php5/fpm/php-fpm.conf

# let's run the darn thing
/usr/sbin/php5-fpm -F --fpm-config /etc/php5/fpm/php-fpm.conf